#region usings
using System;
using System.ComponentModel.Composition;
using System.Windows.Forms;
using System.Collections.Generic;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "colorstudy", Category = "Color", Help = "Basic template with one color in/out", Tags = "")]
	#endregion PluginInfo
	public class ColorcolorstudyNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Input", DefaultColor = new double[] {
			0.1,
			0.2,
			0.3,
			1.0
		})]
		public ISpread<RGBAColor> FInput;
		
		[Output("Output")]
		public ISpread<RGBAColor> FOutput;
		
		[Output("O2")]
		public ISpread<double> FO2;
		
		[Output("O3")]
		public ISpread<double> FO3;
		
		[Output("O4")]
		public ISpread<double> FO4;
		
		[Output("O5")]
		public ISpread<double> FO5;
		
		//[Import()]
		//public ILogger FLogger;
		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			FOutput.SliceCount = SpreadMax;
			double[]Hue =  new double[SpreadMax];
			double[]Sat =  new double[SpreadMax];
			double[]Val =  new double[SpreadMax];
			double[]NRed =  new double[SpreadMax];
			double[]NGre =  new double[SpreadMax];
			double[]NBlu =  new double[SpreadMax];
			//This is the reason why I get only one slice in
            //output, but if I declare an ISpread<double>
            //then I can't store the value coming from
            //VColor.RGBtoHSV or .HSVtoRGB
			
			ISpread<Vector4D>[] Colorz = new ISpread<Vector4D>[]{};
            //I was hoping to fit values in here, and then doing
            //something like FOutput[i]=Colorz[i]; but to no avail
			for (int i = 0; i < SpreadMax; i++)
			{	
				VColor.RGBtoHSV(FInput[i].R, FInput[i].G, FInput[i].B, out Hue[i], out Sat[i], out Val[i]);
				if (Hue[i] <= 0.50)
					{
						Hue[i] = Hue[i] + 0.50;
					}
				else
					{
						Hue[i] = Hue[i] - 0.50;
					}
				
				VColor.HSVtoRGB(Hue[i],Sat[i],Val[i], out NRed[i],out NGre[i],out NBlu[i]);
				//Colorz[i] = {NRed[i],NGre[i],NBlu[i],Finput[i].A};
				
				FO2[i] = NRed[i];
				FO3[i] = NGre[i];
				FO4[i] = NBlu[i];
				FO5[i] = FInput[i].A;
				//FOutput[i] = Colorz[i];
				}
			}
		}
	}